//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class Tmainform : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *MainMenu1;
    TMenuItem *OpenProcess1;
    TMenuItem *About1;
    TGroupBox *GroupBox1;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *lbl_proc_name;
    TLabel *lbl_pid;
    TListBox *memory;
    TGroupBox *GroupBox2;
    TProgressBar *ProgressBar1;
    TMenuItem *Exit1;
    TLabel *Label1;
    TLabel *Label4;
    TRadioButton *rad_jmp;
    TRadioButton *rad_call;
    TRadioButton *rad_ret;
    TComboBox *registers;
    TBevel *Bevel1;
    TLabel *Label5;
    TEdit *opcodes;
    TButton *Button1;
    TBevel *Bevel2;
    TMemo *asm_code;
    TButton *Button2;
    TLabel *Label6;
    TComboBox *mods;
    TButton *Button3;
    void __fastcall OpenProcess1Click(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall About1Click(TObject *Sender);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall rad_jmpMouseUp(TObject *Sender, TMouseButton Button,TShiftState Shift, int X, int Y);
    void __fastcall asm_codeMouseUp(TObject *Sender, TMouseButton Button,TShiftState Shift, int X, int Y);
    void __fastcall rad_callMouseUp(TObject *Sender, TMouseButton Button,TShiftState Shift, int X, int Y);
    void __fastcall rad_retMouseUp(TObject *Sender, TMouseButton Button,TShiftState Shift, int X, int Y);
    void __fastcall registersChange(TObject *Sender);
    void __fastcall Button2Click(TObject *Sender);
    void __fastcall rad_retClick(TObject *Sender);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall Switch_To_RB(void);
    void __fastcall Switch_To_MM(void);
    void __fastcall fatal(AnsiString s);
    void __fastcall CleanUp(void);
    void __fastcall FindInMemory(AnsiString s);
    void __fastcall rad_callClick(TObject *Sender);
    void __fastcall rad_jmpClick(TObject *Sender);
    void __fastcall Button3Click(TObject *Sender);
private:	// User declaration
public:		// User declarations
    __fastcall Tmainform(TComponent* Owner);

    unsigned int pid;
    bool         all_modules;

};
//---------------------------------------------------------------------------
extern PACKAGE Tmainform *mainform;
//---------------------------------------------------------------------------
#endif
