//---------------------------------------------------------------------------

#include <vcl.h>
#include <Tlhelp32.h>
#include <stdio.h>
#include <dstring.h>
#include <string.h>

#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

struct _gbl { char name[32]; unsigned int pid; } glob_proc_list[65535];
char *chosenname;


Tfrmproclist *frmproclist;
//---------------------------------------------------------------------------
__fastcall Tfrmproclist::Tfrmproclist(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall Tfrmproclist::Button1Click(TObject *Sender){
submit();
}
//---------------------------------------------------------------------------
void __fastcall Tfrmproclist::Button2Click(TObject *Sender){
ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall Tfrmproclist::chosenpidKeyPress(TObject *Sender, char &Key){
if (Key ==  27) ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall Tfrmproclist::Button1KeyPress(TObject *Sender, char &Key){
if (Key ==  27) ModalResult = mrCancel;
if(Key == 13) submit();

}
//---------------------------------------------------------------------------
void __fastcall Tfrmproclist::Button2KeyPress(TObject *Sender, char &Key){
if (Key ==  27) ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall Tfrmproclist::ListBox1KeyPress(TObject *Sender, char &Key){
if (Key ==  27) ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

void __fastcall Tfrmproclist::FormShow(TObject *Sender)
{
/* Display list of processes and select on of the processes */

HANDLE snapshot;
PROCESSENTRY32 pe = {0};
BOOL bFlag;
unsigned int i = 0;
char buf[1024];

ListBox1->Items->Clear();
pe.dwSize = sizeof(PROCESSENTRY32);
snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0x0);
if (snapshot == INVALID_HANDLE_VALUE) {
    MessageBox(0, "Error retrieving process list, your machine is doomed.", "Error", MB_OK);
    exit(-1);
    }

bFlag = Process32First(snapshot, &pe);
while(bFlag){
    glob_proc_list[i].pid = pe.th32ProcessID;
    strncpy(glob_proc_list[i].name, pe.szExeFile, 31);
    i++;
    sprintf(buf, "%d%s : %7d  %s",  // format (1  291 blah.exe)
            i,                      // general counter
            (i>9 ? " " : "  "),     // alignment
            pe.th32ProcessID,       // pid
            pe.szExeFile);
    ListBox1->Items->Add(buf);
    bFlag = Process32Next(snapshot, &pe);
    }
}
//---------------------------------------------------------------------------
void __fastcall Tfrmproclist::submit(){
    AnsiString s = "";
    if(ListBox1->ItemIndex == -1) return;
    s.cat_sprintf("Opcode Finder : [ %s ]",
    glob_proc_list[ListBox1->ItemIndex].name);
    mainform->Caption = s;
    mainform->pid = glob_proc_list[ListBox1->ItemIndex].pid;
    // set process information box ok.
    mainform->lbl_pid->Caption = glob_proc_list[ListBox1->ItemIndex].pid;
    mainform->lbl_proc_name->Caption = glob_proc_list[ListBox1->ItemIndex].name;

    // "enable" controls
    mainform->lbl_proc_name->Enabled = true;
    mainform->lbl_pid->Enabled = true;
    mainform->Label2->Enabled = true;
    mainform->Label3->Enabled = true;

    // tell state of all_modules
    mainform->all_modules = CheckBox1->Checked;

    // everything is okay.
    ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall Tfrmproclist::ListBox1Click(TObject *Sender)
{
        AnsiString s = "";
        chosenpid->Text =  glob_proc_list[ListBox1->ItemIndex].pid;
        s.cat_sprintf("Process List : [ %s ] (pid %d)",
                        glob_proc_list[ListBox1->ItemIndex].name,
                        glob_proc_list[ListBox1->ItemIndex].pid);
        frmproclist->Caption = s;
}
//---------------------------------------------------------------------------
void __fastcall Tfrmproclist::ListBox1DblClick(TObject *Sender)
{
submit();
}
//---------------------------------------------------------------------------
